### Set the working directory
setwd("C:/Users/pc_156/Dropbox/Research/Forward variable selection for ultra-high dimensional quantile regression/code - submit R2/code - quantileFR/simulation")

### Library the necessary packages
library(quantreg)
library(rqPen)

### source main functions
source("main_functions.R")

### parameter set-up
n <- 400; p <- 1000; 
tau <- 0.5 # specify the quantile level tau
xi <- log(log(n)) # tuning constant in LIC
m0 <- ceiling(n/log(n)) # tuning parameter for gSC(m0)
K <- 3 # the constant T in paper
Kn <- 30; # the maximum iteration number
set.seed(1) # set the random seed


### Generate the Example 3 of the paper
X <- rnorm(n, 0, 1)
W <- rnorm(n, 0, 1)
C <- rnorm(n, 0, 1)
z <- cbind(X-W-C, W-C, 2*C)
x <- matrix(0, nrow=n, ncol=p); x[,1:3] <- z
for(i in 4:p) x[,i] <- C + rnorm(n,0,1)
y <- x[,1:3]%*%rep(2,3) + rt(n,3)

### SC, gSC(m0), and FR
result.sc <- rq.greedy(x, y, tau, screen.method = "SC", stop.method = "LIC", xi=xi, K=K, m=1, max.iter=Kn)
result.gsc <- rq.greedy(x, y, tau, screen.method = "SC+FR", stop.method = "LIC", xi=xi, m=m0, K=K, max.iter=Kn)
result.fr <- rq.greedy(x, y, tau, screen.method = "FR", stop.method = "LIC", xi=xi, K=K, m=1000, max.iter=Kn)


print(result.sc$ind.act)
print(result.gsc$ind.act)
print(result.fr$ind.act)


